************************;
** ClubSASQuebec_SDD2 **;
************************;
%findfiles(path     = c:\SAS_Training\
         , filespec = *
         , out      = work.extrait_01 (where = (type = "Directory"))
         , recurse  = Y);

data work.repertoires (keep = path);
    set work.extrait_01;
    path = compress(path) || compress(name);
run;

%* Capture le nombre de rpertoire  traiter *;
%let _NombreRepertoire = &sysnobs.;
%put _NombreRepertoire = &_NombreRepertoire.;

%macro creer_libname;
    %* Pour chacun des rpertoires, assigner un libname bidon (incrmental) *;
    %do i = 1 %to &_NombreRepertoire.;
        %* Extraire le "path" du rpertoire  traiter *;
    	data _null_;
    		set repertoires (obs = &i.);
    		call symput("m_Chemin", compress(path));
    	run;
        %* On cre un libname dont les premiers caractres sont L_ *;
        libname L_&i. "&m_Chemin.";
    %end;
%mend;
%creer_libname;

proc sql;
    create table work.tables as
        select  *
        from    dictionary.tables
        where   upcase(substr(libname, 1, 2)) = "L_";

    create table work.colonnes as
        select  *
        from    dictionary.columns
        where   upcase(substr(libname, 1, 2)) = "L_";

    create table work.libnames as
        select  *
        from    dictionary.libnames
        where   upcase(substr(libname, 1, 2)) = "L_" and
                sysname = "Filename";
quit;
